Index: django/core/serializers/json.py
===================================================================
--- django/core/serializers/json.py	(revision 16914)
+++ django/core/serializers/json.py	(working copy)
@@ -17,10 +17,35 @@
     """
     internal_use_only = False
 
+    def start_serialization(self):
+        self._current = None
+        self.json_kwargs = self.options.copy()
+        self.json_kwargs.pop('stream', None)
+        self.json_kwargs.pop('fields', None)
+        self.stream.write("[")
+
     def end_serialization(self):
-        simplejson.dump(self.objects, self.stream, cls=DjangoJSONEncoder, **self.options)
+        if self.options.get("indent"):
+            self.stream.write("\n")
+        self.stream.write("]")
+        if self.options.get("indent"):
+            self.stream.write("\n")
 
+    def end_object(self, obj):
+        # self._current has the field data
+        indent = self.options.get("indent")
+        if not self.first:
+            self.stream.write(",")
+            if not indent:
+                self.stream.write(" ")
+        if indent:
+            self.stream.write("\n")
+        simplejson.dump(self.get_dump_object(obj), self.stream,
+                        cls=DjangoJSONEncoder, **self.json_kwargs)
+        self._current = None
+
     def getvalue(self):
+        # overwrite PythonSerializer.getvalue() with base Serializer.getvalue()
         if callable(getattr(self.stream, 'getvalue', None)):
             return self.stream.getvalue()
 
Index: django/core/serializers/base.py
===================================================================
--- django/core/serializers/base.py	(revision 16914)
+++ django/core/serializers/base.py	(working copy)
@@ -39,6 +39,7 @@
         self.use_natural_keys = options.pop("use_natural_keys", False)
 
         self.start_serialization()
+        self.first = True
         for obj in queryset:
             self.start_object(obj)
             for field in obj._meta.local_fields:
@@ -54,6 +55,8 @@
                     if self.selected_fields is None or field.attname in self.selected_fields:
                         self.handle_m2m_field(obj, field)
             self.end_object(obj)
+            if self.first:
+                self.first = False
         self.end_serialization()
         return self.getvalue()
 
Index: django/core/serializers/python.py
===================================================================
--- django/core/serializers/python.py	(revision 16914)
+++ django/core/serializers/python.py	(working copy)
@@ -27,13 +27,16 @@
         self._current = {}
 
     def end_object(self, obj):
-        self.objects.append({
-            "model"  : smart_unicode(obj._meta),
-            "pk"     : smart_unicode(obj._get_pk_val(), strings_only=True),
-            "fields" : self._current
-        })
+        self.objects.append(self.get_dump_object(obj))
         self._current = None
 
+    def get_dump_object(self, obj):
+        return {
+            "pk": smart_unicode(obj._get_pk_val(), strings_only=True),
+            "model": smart_unicode(obj._meta),
+            "fields": self._current
+        }
+
     def handle_field(self, obj, field):
         value = field._get_val_from_obj(obj)
         # Protected types (i.e., primitives like None, numbers, dates,
Index: django/core/management/commands/dumpdata.py
===================================================================
--- django/core/management/commands/dumpdata.py	(revision 16914)
+++ django/core/management/commands/dumpdata.py	(working copy)
@@ -4,6 +4,7 @@
 from django.db import router, DEFAULT_DB_ALIAS
 from django.utils.datastructures import SortedDict
 
+import sys
 from optparse import make_option
 
 class Command(BaseCommand):
@@ -30,8 +31,8 @@
     def handle(self, *app_labels, **options):
         from django.db.models import get_app, get_apps, get_model
 
-        format = options.get('format','json')
-        indent = options.get('indent',None)
+        format = options.get('format', 'json')
+        indent = options.get('indent', None)
         using = options.get('database', DEFAULT_DB_ALIAS)
         excludes = options.get('exclude',[])
         show_traceback = options.get('traceback', False)
@@ -97,20 +98,23 @@
         except KeyError:
             raise CommandError("Unknown serialization format: %s" % format)
 
-        # Now collate the objects to be serialized.
-        objects = []
-        for model in sort_dependencies(app_list.items()):
-            if model in excluded_models:
-                continue
-            if not model._meta.proxy and router.allow_syncdb(using, model):
-                if use_base_manager:
-                    objects.extend(model._base_manager.using(using).all())
-                else:
-                    objects.extend(model._default_manager.using(using).all())
+        def get_objects():
+            # Collate the objects to be serialized.
+            for model in sort_dependencies(app_list.items()):
+                if model in excluded_models:
+                    continue
+                if not model._meta.proxy and router.allow_syncdb(using, model):
+                    if use_base_manager:
+                        objects = model._base_manager
+                    else:
+                        objects = model._default_manager
+                    for obj in objects.using(using).\
+                            order_by(model._meta.pk.name).iterator():
+                        yield obj
 
         try:
-            return serializers.serialize(format, objects, indent=indent,
-                        use_natural_keys=use_natural_keys)
+            serializers.serialize(format, get_objects(), indent=indent,
+                    use_natural_keys=use_natural_keys, stream=sys.stdout)
         except Exception, e:
             if show_traceback:
                 raise